package com.ruoyi.framework.web.service;

import java.time.LocalDate;
import java.util.Date;

import com.ruoyi.common.config.RuoYiConfig;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.model.AppRegisterUser;
import com.ruoyi.common.utils.ip.IpUtils;
import com.ruoyi.system.domain.StUser;
import com.ruoyi.system.domain.UserInfo;
import com.ruoyi.system.service.IStUserService;
import com.ruoyi.system.service.IUserInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.ruoyi.common.constant.CacheConstants;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.constant.UserConstants;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.core.domain.model.RegisterBody;
import com.ruoyi.common.core.redis.RedisCache;
import com.ruoyi.common.exception.user.CaptchaException;
import com.ruoyi.common.exception.user.CaptchaExpireException;
import com.ruoyi.common.utils.MessageUtils;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.framework.manager.AsyncManager;
import com.ruoyi.framework.manager.factory.AsyncFactory;
import com.ruoyi.system.service.ISysConfigService;
import com.ruoyi.system.service.ISysUserService;
import org.springframework.transaction.annotation.Transactional;

/**
 * 注册校验方法
 * 
 * @author ruoyi
 */
@Component
public class SysRegisterService
{
    @Autowired
    private ISysUserService userService;

    @Autowired
    private IUserInfoService userInfoService;

    @Autowired
    private ISysConfigService configService;

    @Autowired
    private RedisCache redisCache;

    @Autowired
    private IStUserService stUserService;

    /**
     * 注册
     */
    public String register(RegisterBody registerBody)
    {
        String msg = "", username = registerBody.getUsername(), password = registerBody.getPassword();
        SysUser sysUser = new SysUser();
        sysUser.setUserName(username);

        // 验证码开关
        boolean captchaEnabled = configService.selectCaptchaEnabled();
        if (captchaEnabled)
        {
            validateCaptcha(username, registerBody.getCode(), registerBody.getUuid());
        }

        if (StringUtils.isEmpty(username))
        {
            msg = "用户名不能为空";
        }
        else if (StringUtils.isEmpty(password))
        {
            msg = "用户密码不能为空";
        }
        else if (username.length() < UserConstants.USERNAME_MIN_LENGTH
                || username.length() > UserConstants.USERNAME_MAX_LENGTH)
        {
            msg = "账户长度必须在2到20个字符之间";
        }
        else if (password.length() < UserConstants.PASSWORD_MIN_LENGTH
                || password.length() > UserConstants.PASSWORD_MAX_LENGTH)
        {
            msg = "密码长度必须在5到20个字符之间";
        }
        else if (!userService.checkUserNameUnique(sysUser))
        {
            msg = "保存用户'" + username + "'失败，注册账号已存在";
        }
        else
        {
            sysUser.setNickName(username);
            sysUser.setPassword(SecurityUtils.encryptPassword(password));
            boolean regFlag = userService.registerUser(sysUser);
            if (!regFlag)
            {
                msg = "注册失败,请联系系统管理人员";
            }
            else
            {
                AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.REGISTER, MessageUtils.message("user.register.success")));
            }
        }
        return msg;
    }

    /**
     * 校验验证码
     * 
     * @param username 用户名
     * @param code 验证码
     * @param uuid 唯一标识
     * @return 结果
     */
    public void validateCaptcha(String username, String code, String uuid)
    {
        String verifyKey = CacheConstants.CAPTCHA_CODE_KEY + StringUtils.nvl(uuid, "");
        String captcha = redisCache.getCacheObject(verifyKey);
        redisCache.deleteObject(verifyKey);
        if (captcha == null)
        {
            throw new CaptchaExpireException();
        }
        if (!code.equalsIgnoreCase(captcha))
        {
            throw new CaptchaException();
        }
    }

    @Transactional // 保证事务的一致性
    public String AppRegister(AppRegisterUser registerBody) {
        String msg = "", username = registerBody.getUsername(), password = registerBody.getPassword();

        //先验证手机号是否已经注册
        int i = userService.checkUserPhone(username);
        if (i > 0) {
            return "该手机号已经注册";
        }

        SysUser sysUser = new SysUser();
        sysUser.setUserName(username);
        sysUser.setPhonenumber(username);

//        sysUser.setAvatar(RuoYiConfig.getDomain()+"/profile/avatar/avatar_default.jpg");
        sysUser.setUserType("0000000000");

        UserInfo userInfo = new UserInfo();


        //------------------------ 验证码开关 开发环境先关闭----------------------------------
        boolean captchaEnabled = configService.selectCaptchaEnabled();
        if (captchaEnabled)
        {
            appRegistervalidateCaptcha(username, registerBody.getCode());
        }
//        //----------------------end 验证码开关-------------------------------------------

        if (StringUtils.isEmpty(username))
        {
            msg = "用户名不能为空";
        }
        else if (StringUtils.isEmpty(password))
        {
            msg = "用户密码不能为空";
        }
        else if (username.length() < UserConstants.USERNAME_MIN_LENGTH
                || username.length() > UserConstants.USERNAME_MAX_LENGTH)
        {
            msg = "账户长度必须在2到20个字符之间";
        }
        else if (password.length() < UserConstants.PASSWORD_MIN_LENGTH
                || password.length() > UserConstants.PASSWORD_MAX_LENGTH)
        {
            msg = "密码长度必须在5到20个字符之间";
        }
        else if (!userService.checkUserNameUnique(sysUser))
        {
            msg = "保存用户'" + username + "'失败，注册账号已存在";
        }
        else
        {
            sysUser.setNickName(registerBody.getNickname());
            sysUser.setPassword(SecurityUtils.encryptPassword(password));

            String ip = IpUtils.getIpAddr();
            sysUser.setLoginIp(ip);

            // 注册账号
            boolean regFlag = userService.registerUser(sysUser);


            if (!regFlag)
            {
                msg = "账号注册失败,请联系系统管理人员";
            }
            else
            {
                // 查询数据库中的用户账号信息
                SysUser newSysUser = userService.selectUserByUserName(username);
                //---------------------------- 新建用户个人信息--------------------------------------------
                userInfo.setUserId(newSysUser.getUserId());
                userInfo.setPhonenumber(username);
                userInfo.setBackGround(RuoYiConfig.getDomain()+"/profile/background/background_default.jpg");
                // 获取当前时间的毫秒值
                long currentTimeMillis = System.currentTimeMillis();
                // 利用毫秒值构造Date对象
                Date currentDate = new Date(currentTimeMillis);
                userInfo.setUpdateTime(currentDate);

                //设置上一次计算时间大约为10天前
                Date calculationTime = new Date(currentTimeMillis-1000000000);
                userInfo.setCalculationTime(calculationTime);

                int infoFlag = userInfoService.insertUserInfo(userInfo);
                if (infoFlag == 0) {
                    msg = "个人信息注册失败,请联系系统管理人员";
                    return msg;
                }

                //-----------------------------------用户个人统计信息注册------------------------------------
                StUser stUser = new StUser();
                stUser.setUserId(newSysUser.getUserId());
                stUser.setUpdateTime(currentDate);

                LocalDate now = LocalDate.now();
                LocalDate twoDaysAgo = now.minusDays(2);
                stUser.setDate(twoDaysAgo);

                stUserService.insertStUser(stUser);



                System.out.println(infoFlag);

                AsyncManager.me().execute(AsyncFactory.recordLogininfor(username, Constants.REGISTER, MessageUtils.message("user.register.success")));
            }
        }
        return msg;
    }

    private void appRegistervalidateCaptcha(String username, String code) {
        String verifyKey = CacheConstants.CAPTCHA_CODE_KEY + StringUtils.nvl(username, "");
        String captcha = redisCache.getCacheObject(verifyKey);
        redisCache.deleteObject(verifyKey);
        if (captcha == null)
        {
            throw new CaptchaExpireException();
        }
        if (!code.equalsIgnoreCase(captcha))
        {
            throw new CaptchaException();
        }
    }


}
